---------------------------

-- Start of lib\menu.lua --

---------------------------



------------------------------

-- Start of lib\process.lua --

------------------------------



---------------------------

-- Start of lib\glib.lua --

---------------------------



platform.apiLevel = '2.3'

local disp=platform.window
local dispX=disp:width()
local dispY=disp:height()

function centerText(gc, text, midX, midY)
	gc:drawString(text, midX-gc:getStringWidth(text)/2, midY-gc:getStringHeight(text)/2, "top")
end

function centerTextWithRect(gc, text, midX, midY, rectColor)
	centerText(gc, text, midX, midY)
	gc:setColorRGB(rectColor)
	gc:drawRect(midX-gc:getStringWidth(text)/2, midY-gc:getStringHeight(text)/2, gc:getStringWidth(text), gc:getStringHeight(text))
end

function drawBoard(gc, sBX, sBY, sX, sY, bW, bH)--sB-sizeBoard, sX-startX, sY-startY, bW-boardWidth, bH-boardHeight
	local sizeRectX=bW/sBX
	local sizeRectY=bH/sBY
    for i=0, sBY do
        gc:drawLine(sX, sY+sizeRectY*i, sX+bW, sY+sizeRectY*i)
    end
	for i=0, sBX do
		gc:drawLine(sX+sizeRectX*i, sY, sX+sizeRectX*i, sY+bH)
	end
end

function fTriangle(gc, x1, y1, x2, y2, x3, y3)--f=fill
	local points={{x1, y1}, {x2, y2}, {x3, y3}}
	for i=1, 3 do
		for j=i,3 do
			if points[i][2]>points[j][2] then
				local tmp={points[i][1], points[i][2]}
				points[i][1]=points[j][1]
				points[i][2]=points[j][2]
				points[j][1]=tmp[1]
				points[j][2]=tmp[2]
			elseif points[i][2]==points[j][2] then
				if points[i][1]>points[j][1] then
					local tmp={points[i][1], points[i][2]}
					points[i][1]=points[j][1]
					points[i][2]=points[j][2]
					points[j][1]=tmp[1]
					points[j][2]=tmp[2]
				end
			end
		end
	end
	if points[1][2]==points[2][2] then--two points are smaller coords. increment y
		local xSlope1=(points[3][1]-points[1][1])/(points[3][2]-points[1][2])
		local xSlope2=(points[3][1]-points[2][1])/(points[3][2]-points[2][2])
		local startX=points[1][1]
		local endX=points[2][1]
		if endX<startX then
			local tmp=xSlope1
			xSlope1=xSlope2
			xSlope2=tmp
			tmp=startX
			startX=endX
			endX=tmp
		end
		for i=points[1][2], points[3][2] do
			gc:drawLine(startX, i, endX, i)
			startX=startX+xSlope1
			endX=endX+xSlope2
		end
	elseif points[2][2]==points[3][2] then--two points are larger coords. decrement y
		local xSlope1=-(points[1][1]-points[2][1])/(points[1][2]-points[2][2])
		local xSlope2=-(points[1][1]-points[3][1])/(points[1][2]-points[3][2])
		local startX=points[2][1]
		local endX=points[3][1]
		if endX<startX then
			local tmp=xSlope1
			xSlope1=xSlope2
			xSlope2=tmp
			tmp=startX
			startX=endX
			endX=tmp
		end
		for i=points[2][2], points[1][2], -1 do
			gc:drawLine(startX, i, endX, i)
			startX=startX+xSlope1
			endX=endX+xSlope2
		end
	else
		local xSlope=(points[3][2]-points[1][2])/(points[3][1]-points[1][1])
		local newX2=points[1][1]+1/xSlope*(points[2][2]-points[1][2])
		fTriangle(gc, points[2][1], points[2][2], newX2, points[2][2], points[3][1], points[3][2])
		fTriangle(gc, points[2][1], points[2][2], newX2, points[2][2], points[1][1], points[1][2])
	end
end

do shape=class()
	function shape.clone(s)
		local tmpShape=shape()
		tmpShape.type=s.type
		for i=1, #s.coords do
			tmpShape.coords[i]=s.coords[i]
			tmpShape.tmpCoords[i]=s.tmpCoords[i]
		end
		tmpShape.data=s.data
		tmpShape.rotAngle=s.rotAngle
		tmpShape.color=s.color
		tmpShape.color2=s.color2
		tmpShape.tx=s.tx
		tmpShape.ty=s.ty
		tmpShape.rotPtX=s.PtX
		tmpShape.rotPtY=s.PtY
		tmpShape.dilX=s.dilX
		tmpShape.dilY=s.dilY
		tmpShape.dil=s.dil
		return tmpShape
	end
	
	function shape:init()
		self.type=0
		self.coords={}
		self.tmpCoords={}
		self.data=0
		self.rotAngle=0
		self.color=0
		self.color2=0
		self.tx=0
		self.ty=0
		self.rotPtX=0
		self.rotPtY=0
		self.dilX=0
		self.dilY=0
		self.dil=1
	end
	function shape:moveCoords(s, x, y)
		local mag=math.sqrt((self.coords[s])^2+(self.coords[s+1])^2)
		if mag~=0 then
			local angle=math.asin((self.coords[s+1])/mag)+self.rotAngle
			self.coords[s]=mag*math.cos(angle)
			self.coords[s+1]=mag*math.sin(angle)
		else
			self.coords[s]=0
			self.coords[s+1]=0
		end
		self.coords[s]=self.coords[s]+x+self.tx
		self.coords[s+1]=self.coords[s+1]+y+self.ty
	end
	function shape:translate(x, y)
		self.tx=x
		self.ty=y
	end
	function shape:rotate(angle)
		self.rotAngle=angle%360
	end
	function shape:setRotPoint(x, y)
		
	end
	function shape:setDilatePoint(x, y)
		self.dilX=x
		self.dilY=y
	end
	function shape:dilate(dilation)
		self.dil=dilation
	end
	function shape:setColorRGB(hex)
		self.color=hex
	end
	function shape:set2ndColorRGB(hex)
		self.color2=hex
	end
	function shape:point(x, y)
		self.type=1
		self.coords={x, y}
	end
	function shape:line(x1, y1, x2, y2)
		self.type=2
		self.coords={x1, y1, x2, y2}
	end
	function shape:polyLine(points)
		self.type=3
		self.coords={}
		for i=1, #points do
			self.coords[i]=points[i]
		end
	end
	function shape:drawRect(x, y, width, height)
		self.type=4
		self.coords={x, y, width, height}
	end
	function shape:drawArc(x, y, width, height, startAngle, arcAngle)
		self.type=5
		self.coords={x, y, width, height, startAngle, arcAngle}
	end
	function shape:drawString(text, x, y)
		self.type=6
		self.coords={x,y}
		self.data=text
	end
	function shape:image(image, x, y)
		self.type=7
		shape.coords={x,y}
		self.data=image
	end
	function shape:drawRoundRect(x, y, width, height, radius)
		self.type=8
		self.coords={x, y, width, height, radius}
	end
	function shape:fillPolygon(points)
		self.type=9
		self.coords={}
		for i=1, #points do
			self.coords[i]=points[i]
		end
	end
	function shape:fillRect(x, y, width, height)
		self.type=10
		self.coords={x, y, width, height}
	end
	function shape:fillArc(x, y, width, height, startAngle, arcAngle)
		self.type=11
		self.coords={x, y, width, height, startAngle, arcAngle}
	end
	function shape:fillRoundRect(x, y, width, height, radius)
		self.type=12
		self.coords={x, y, width, height, radius}
	end
	function shape:centeredString(text, x, y)
		self.type=13
		self.coords={x, y}
		self.data=text
	end
	function shape:gradientRect(x, y, width, height, d)
		self.type=14
		self.coords={x, y, width, heigh, d}
	end
	function shape:fillCircle(x, y, r)
		self.type=15
		self.coords={x, y, r}
	end
	function shape:gradientCircle(x, y, r)
		self.type=16
		self.coords={x, y, r}
	end
	function shape:draw(gc, x,y)
		gc:setColorRGB(self.color)
		for i=1, #self.coords do
			self.tmpCoords[i]=self.coords[i]
		end
		if self.type==1 then
			self:moveCoords(1, x, y)
			gc:drawPoint(self.coords[1], self.coords[2])
		elseif self.type==2 then
			self:moveCoords(1, x, y)
			self:moveCoords(3, x, y)
			gc:drawLine(self.coords[1], self.coords[2], self.coords[3], self.coords[4])
		elseif self.type==3 then
			for i=1, #self.coords, 2 do
				self:moveCoords(i, x, y)
			end
			gc:drawPolyLine(self.coords)
		elseif self.type==4 then
			self:moveCoords(1, x, y)
			gc:drawRect(self.coords[1], self.coords[2], self.coords[3], self.coords[4])
		elseif self.type==5 then
			self.coords[1]=self.coords[1]+self.tx+x
			self.coords[2]=self.coords[2]+self.ty+y
			self.coords[5]=(self.coords[5]+self.rotAngle)%360
			if self.coords[5]>=360 then
				self.coords[5]=self.coords[5]-360
			end
			if self.coords[6]>=360 then
				self.coords[6]=self.coords[6]-360
			end
			gc:drawArc(self.coords[1], self.coords[2], self.coords[3], self.coords[4], self.coords[5], self.coords[6])
		elseif self.type==6 then
			self:moveCoords(1, x, y)
			gc:drawString(self.data, self.coords[1], self.coords[2])
		elseif self.type==7 then
			self:moveCoords(1, x, y)
			gc:drawImage(self.data, self.coords[1], self.coords[2])
		elseif self.type==8 then
			self:moveCoords(1, x, y)
			gc:drawRoundRect(self.coords[1], self.coords[2], self.coords[3], self.coords[4], self.coords[5])
		elseif self.type==9 then
			for i=1, #self.coords, 2 do
				self:moveCoords(i, x, y)
			end
			gc:fillPolygon(self.coords)
		elseif self.type==10 then
			self:moveCoords(1, x, y)
			gc:fillRect(self.coords[1], self.coords[2], self.coords[3], self.coords[4])
		elseif self.type==11 then
			self.coords[1]=self.coords[1]+self.tx+x
			self.coords[2]=self.coords[2]+self.ty+y
			self.coords[5]=(self.coords[5]+self.rotAngle)%360
			if self.coords[5]>=360 then
				self.coords[5]=self.coords[5]%360
			end
			if self.coords[6]>=360 then
				self.coords[6]=self.coords[6]%360
			end
			gc:fillArc(self.coords[1], self.coords[2], self.coords[3], self.coords[4], self.coords[5], self.coords[6])
		elseif self.type==12 then
			self:moveCoords(1, x, y)
			gc:fillRoundRect(self.coords[1], self.coords[2], self.coords[3], self.coords[4], self.coords[5])
		elseif self.type==13 then
			self:moveCoords(1, x, y)
			centerText(gc, self.data, self.coords[1], self.coords[2])
		elseif self.type==14 then
			self:moveCoords(1, x, y)
			local tmpcolors1={math.floor(self.color/0x10000), math.floor((self.color%0x10000)/0x100), self.color%0x100}
			local tmpcolors2={math.floor(self.color2/0x10000), math.floor((self.color2%0x10000)/0x100), self.color%0x100}
			gc:fillGradientRect(self.coords[1], self.coords[2], self.coords[3], self.coords[4], tmpcolors1, tmpcolors2)
		elseif self.type==15 then
			self:moveCoords(1, x, y)
			gc:fillCircle(self.coords[1], self.coords[2], self.coords[3])
		elseif self.type==16 then
			self.coords[1]=self.coords[1]+self.tx+x
			self.coords[2]=self.coords[2]+self.ty+y
			local tmpcolors1={math.floor(self.color/0x10000), math.floor((self.color%0x10000)/0x100), self.color%0x100}
            local tmpcolors2={math.floor(self.color2/0x10000), math.floor((self.color2%0x10000)/0x100), self.color%0x100}
			gc:fillGradientCircle(self.coords[1], self.coords[2], self.coords[3], tmpcolors1, tmpcolors2)
		end
		for i=1, #self.coords do
			self.coords[i]=self.tmpCoords[i]
		end
	end
end

do glib=class()
	function glib:init(width, height)
		self.width=width
		self.height=height
		self.Shapes={}
		self.rotAngle=0
	end
	function glib:addShape(s, x, y, rotAngle)
		self.Shapes[#self.Shapes+1]=shape.clone(s)
		self.Shapes[#self.Shapes]:translate(x, y)
	end
	function glib:rotate(angle)
		self.rotAngle=angle%360
	end
	function glib:changeRot(angle)
		self.rotAngle=(self.rotAngle+angle)%360
	end
	function glib:draw(gc, x, y, mode)
		local changeX=0
		local changeY=0
		if mode~=nil then
			if mode=="middle" then
				changeX=self.width/2
				changeY=self.height/2
			elseif mode=="midtop" then
				changeX=self.width/2
			elseif mode=="midbottom" then
				changeX=self.width/2
				changeY=self.height
			end
		end
		gc:clipRect("set", x-changeX, y-changeY, self.width, self.height)
		for i=1, #self.Shapes do
			local tmp=self.Shapes[i].rotAngle
			self.Shapes[i]:rotate(self.Shapes[i].rotAngle+self.rotAngle)
			self.Shapes[i]:draw(gc, x, y)
			self.Shapes[i]:rotate(tmp)
		end
		gc:clipRect("reset")
	end
end

-------------------------

-- End of lib\glib.lua --

-------------------------


require ('physics')

local vec=physics.Vect
local mouse=vec(0,0)

local millis=timer.getMilliSecCounter

local timerInvalidate=false

lockTopProcess=false

process = class()

process.name=""
process.inputEnabled=true
process.priority=0--1 is always. 2 is run at least once every two runs. 3 can't skip 4 runs in a row. 4 only runs if fps is above target. Also set 0 if disabling process. This only increments unsuc/sets unsuc to 0 upon timer run
process.paintPriority=0--0 if a background process
process.targetFPS=30--if fps dips below target, then if priority is not 1 it will skip running the process unless it meets the minimum run amount
process.lastRun=0--set to millis() upon starting process
process.lastPaint=0
process.numUnsucRuns=0--resets after a successful run
process.numPaintUnsuc=0

function process:setDefaults()
	self.inputEnabled=true
	self.priority=1
	self.paintPriority=1
	self.targetFPS=30
	self.lastRun=millis()
	self.lastPaint=millis()
end

function process:deactivate() 
	self.priority=0
	self.paintPriority=0
	self.inputEnabled=false
end

function process:deactivatePrior()
	self.priority=0
	self.paintPriority=0
end

function process:setBackground(priority)
	if priority~=nil then
		self.priority=priority
		self.lastRun=millis()
	end
	self.paintPriority=0
end

function process:setPaintable(priority)
	self.paintPriority=priority
	self.lastPaint=millis()
end

function process:setPriorities(prior, paintPrior, input)
	self.priority=prior
	self.paintPriority=paintPrior
	self.lastRun=millis()
	self.lastPaint=millis()
	if input~=nil then
		self.inputEnabled=input
	else
		self.inputEnabled=true
	end
end

function process:init() end

function process:paint(gc, x, y, width, height) end
function process:timer() end
function process:charIn(ch) end
function process:arrowKey(key) end
function process:escapeKey() end
function process:enterKey() end
function process:tabKey() end
function process:contextMenu() end
function process:backtabKey() end
function process:backspaceKey() end
function process:clearKey() end
function process:mouseMove(x, y) end
function process:mouseDown(x, y) end
function process:mouseUp() end
function process:rightMouseDown(x, y) end
function process:help() end
function process:varChange(varList) end
function process:Open() end
function process:Close() end
function process:activate() end
function process:recovery() end

local processes = {}
 
function PushProcess(proc)
	table.insert(processes, proc)
	proc:setDefaults()
	proc:Open()
    disp:invalidate()
end
 
function PullProcess()
    if #processes > 1 then
		print("pulling: "..processes[#processes].name)
		processes[#processes]:Close()
        table.remove(processes)
		if #processes>0 then
			processes[#processes]:activate()
		end
        disp:invalidate()
		collectgarbage()
    end
end
 
 
 local eventCatcher={}
 
-- Link events to processManager
function eventCatcher:paint(gc, x, y, width, height)
	if not lockTopProcess then
		for _, proc in pairs(processes) do
			if proc.paintPriority==1 then
				proc:paint(gc, x, y, width, height)
			elseif proc.paintPriority==2 then
				if millis()-proc.lastPaint>=1000/proc.targetFPS then
					proc:paint(gc)
					proc.lastPaint=millis()
				else
					if proc.numPaintUnsuc>=1 then
						proc:paint(gc, x, y, width, height)
						proc.numPaintUnsuc=0
						proc.lastPaint=millis()
					else
						proc.numPaintUnsuc=proc.numPaintUnsuc+1
						proc.lastPaint=millis()
					end
				end
			elseif proc.paintPriority==3 then
				if millis()-proc.lastPaint>=1000/proc.targetFPS then
					proc:paint(gc, x, y, width, height)
					proc.lastPaint=millis()
				else
					if proc.numPaintUnsuc>=3 then
						proc:paint(gc, x, y, width, height)
						proc.numPaintUnsuc=0
						proc.lastPaint=millis()
					else
						proc.numPaintUnsuc=proc.numPaintUnsuc+1
						proc.lastPaint=millis()
					end
				end
			elseif proc.paintPriority==4 then
				if millis()-proc.lastPaint>=1000/proc.targetFPS then
					proc:paint(gc, x, y, width, height)
					proc.lastPaint=millis()
				end
			end
		end
	else
		processes[#processes]:paint(gc, x, y, width, height)
		processes[#processes].lastPaint=millis()
    end
end
 
function eventCatcher:timer()
	if not lockTopProcess then
		for _, proc in pairs(processes) do
			if proc.priority==1 then
				proc:timer()
				proc.lastRun=millis()
			elseif proc.priority==2 then
				if millis()-proc.lastRun<=1000/proc.targetFPS then
					proc:timer()
					proc.lastRun=millis()
				else
					if proc.numPaintUnsuc>=1 then
						proc:timer()
						proc.numPaintUnsuc=0
						proc.lastRun=millis()
					else
						proc.numPaintUnsuc=proc.numPaintUnsuc+1
						proc.lastRun=millis()
					end
				end
			elseif proc.priority==3 then
				if millis()-proc.lastRun<=1000/proc.targetFPS then
					proc:timer()
					proc.lastRun=millis()
				else
					if proc.numPaintUnsuc>=3 then
						proc:timer()
						proc.numPaintUnsuc=0
						proc.lastRun=millis()
					else
						proc.numPaintUnsuc=proc.numPaintUnsuc+1
						proc.lastRun=millis()
					end
				end
			elseif proc.priority==4 then
				if millis()-proc.lastRun<=1000/proc.targetFPS then
					proc:timer()
					proc.lastRun=millis()
				end
			end
		end
	else
		processes[#processes]:timer()
		processes[#processes].lastRun=millis()
	end
	if timerInvalidate then
		disp:invalidate()
	end
end
 
function eventCatcher:charIn(ch)
	if not lockTopProcess then
		for i=1, #processes do
			if processes[i]~=nil then
				proc=processes[i]
				if proc.inputEnabled then
					proc:charIn(ch)
				end
			end
		end
	else
		processes[#processes]:charIn(ch)
	end
	--disp:invalidate() 
end
function eventCatcher:arrowKey(key) 
	if not lockTopProcess then
		for i=1, #processes do
			if processes[i]~=nil then
				proc=processes[i]
				if proc.inputEnabled then
					proc:arrowKey(key)
				end
			end
		end
	else
		processes[#processes]:arrowKey(key)
	end
	--disp:invalidate() 
end
function eventCatcher:escapeKey()	
	if not lockTopProcess then
		for i=1, #processes do
			if processes[i]~=nil then
				proc=processes[i]
				if proc.inputEnabled then
					proc:escapeKey()
				end
			end
		end
	else
		processes[#processes]:escapeKey()
	end
	--disp:invalidate() 
end
function eventCatcher:enterKey() 
	if not lockTopProcess then
		for i=1, #processes do
			if processes[i]~=nil then
				proc=processes[i]
				if proc.inputEnabled then
					proc:enterKey()
				end
			end
		end
	else
		processes[#processes]:enterKey()
	end
	--disp:invalidate() 
end
function eventCatcher:tabKey() 
	if not lockTopProcess then
		for i=1, #processes do
			if processes[i]~=nil then
				proc=processes[i]
				if proc.inputEnabled then
					proc:tabKey()
				end
			end
		end
	else
		processes[#processes]:tabKey()
	end
	--disp:invalidate() 
end
function eventCatcher:contextMenu() 
	for i=1, #processes do
		if processes[i]~=nil then
			proc=processes[i]
			if proc.inputEnabled then
				proc:contextMenu()
			end
		end
    end
	--disp:invalidate() 
end
function eventCatcher:backtabKey() 
	if not lockTopProcess then
		for i=1, #processes do
			if processes[i]~=nil then
				proc=processes[i]
				if proc.inputEnabled then
					proc:backtabKey()
				end
			end
		end
	else
		processes[#processes]:backtabKey()
	end
	--disp:invalidate() 
end
function eventCatcher:backspaceKey() 
	if not lockTopProcess then
		for i=1, #processes do
			if processes[i]~=nil then
				proc=processes[i]
				if proc.inputEnabled then
					proc:backspaceKey()
				end
			end
		end
	else
		processes[#processes]:backspaceKey()
	end
	--disp:invalidate() 
end
function eventCatcher:clearKey() 
	if not lockTopProcess then
		for i=1, #processes do
			if processes[i]~=nil then
				proc=processes[i]
				if proc.inputEnabled then
					proc:clearKey()
				end
			end
		end
	else
		processes[#processes]:clearKey()
	end
	--disp:invalidate()
end
function eventCatcher:grabDown(x, y)
	if not lockTopProcess then
		for i=1, #processes do
			if processes[i]~=nil then
				proc=processes[i]
				if proc.inputEnabled then
					proc:grabDown(x, y)
				end
			end
		end
	else
		processes[#processes]:grabDown(x, y)
	end
	--disp:invalidate()
end
function eventCatcher:grabUp() 
	if not lockTopProcess then
		for i=1, #processes do
			if processes[i]~=nil then
				proc=processes[i]
				if proc.inputEnabled then
					proc:grabUp()
				end
			end
		end
	else
		processes[#processes]:grabUp()
	end
end
function eventCatcher:mouseDown(x, y) 
	if not lockTopProcess then
		for i=1, #processes do
			if processes[i]~=nil then
				proc=processes[i]
				if proc.inputEnabled then
					proc:mouseDown(x, y)
				end
			end
		end
	else
		processes[#processes]:mouseDown(x, y)
	end
	--disp:invalidate()
end
function eventCatcher:mouseUp() 
	if not lockTopProcess then
		for i=1, #processes do
			if processes[i]~=nil then
				proc=processes[i]
				if proc.inputEnabled then
					proc:mouseUp()
				end
			end
		end
	else
		processes[#processes]:mouseUp()
	end
end
function eventCatcher:mouseMove(x, y) 
	mouse=vec(x, y)
	if not lockTopProcess then
		for i=1, #processes do
			if processes[i]~=nil then
				proc=processes[i]
				if proc.inputEnabled then
					proc:mouseMove(x, y)
				end
			end
		end
	else
		processes[#processes]:mouseMove(x, y)
	end
end
function eventCatcher:rightMouseDown(x, y) 
	if not lockTopProcess then
		for i=1, #processes do
			if processes[i]~=nil then
				proc=processes[i]
				if proc.inputEnabled then
					proc:rightMouseDown(x, y)
				end
			end
		end
	else
		processes[#processes]:rightMouseDown(x,y)
	end
	--disp:invalidate()
end
function eventCatcher:help() 
	if not lockTopProcess then
		for i=1, #processes do
			if processes[i]~=nil then
				proc=processes[i]
				if proc.inputEnabled then
					proc:help()
				end
			end
		end
	else
		processes[#processes]:help()
	end
	--disp:invalidate()
end
function eventCatcher:varChange(varList) 
	if not lockTopProcess then
		for i=1, #processes do
			if processes[i]~=nil then
				if proc.inputEnabled then
					proc:varChange(varList)
				end
			end
		end
	else
		processes[#processes]:varChange(varList)
	end
	--disp:invalidate()
end

local eventDistributer = function (...)
     eventCatcher[triggeredEvent](eventCatcher, ...)
end

eventCatcher.__index = function (tbl, event)
    if eventCatcher[event] then
        triggeredEvent = event
        return eventDistributer
    end
end

setmetatable(on, eventCatcher)

function printProcessNames()
	for i=1, #processes do
		if processes[i]~=nil then
			print(processes[i].name)
		end
	end
end

function unLockProcesses()
	for _, proc in pairs(processes) do
		proc.lastRun=millis()
		proc.lastPaint=millis()
	end
	lockTopProcess=false
end

function procRecovery()
	for _, proc in pairs(processes) do
		proc:recovery()
	end
end

----------------------------

-- End of lib\process.lua --

----------------------------


function cpyTable(tbl)
	local r={}
	
	if type(tbl)=="table" then
		for i, t in pairs(tbl) do
			r[i]=cpyTable(t)
		end
	else
		r=tbl
	end
	
	return r
end

function checkBounds(amount, data)--checks if bounds fall within any dimension array/set, amount has table index, data has minimum for the first #amount items, and then width, height, etc for next #amount items
	for i=1, #amount do
		if amount[i]<data[i] or amount[i]>=data[i]+data[i+#amount] then
			return false
		end
	end
	return true
end

function round(n)
	return math.floor(n+0.5)
end

local milSecs=1000--seconds to milliseconds
local minSecs=60--seconds to minutes

do menu=cpyTable(process)--name, item
	menu.items={}
	menu.backs={}
	menu.x=1
	menu.curBack=1
	menu.prevBackTime=millis()
	menu.backSecs=5
	local rectColor=0x00FF7F
	local textColor=0x000000
	
	function menu:reset()
		self.items={}
		self.back={}
		self.x=1
		self.curBack=1
		self.prevBackTime=millis()
		self.backSecs=5
	end
	
	function menu:setMenuItem(item)
		self.items=item.items
		self.backs=item.backs
		self.x=item.x
		self.curBack=item.curBack
		self.prevBackTime=item.prevBackTime
		self.backSecs=item.backSecs
	end
	
	function menu:drawBackground(gc)
		if self.backs[self.curBack]~=nil then
			gc:drawImage(self.backs[self.curBack], -1,0)
		end
	end
	
	function menu:arrowKey(key)
		if key=="up" then
			if self.x>1 then
				self.x=self.x-1
			else
				self.x=#self.items
			end
		elseif key=="down" then
			if self.x<#self.items then
				self.x=self.x+1
			else
				self.x=1
			end
		end
		disp:invalidate()
	end
	function menu:add(name, item)
		self.items[#self.items+1]={n=name, i=item, id=#self.items+1}
	end
	function menu:paint(gc)
		self:drawBackground(gc)
		gc:setFont("sansserif", "r", 14)
		for _, item in pairs(self.items) do
			gc:setColorRGB(textColor)
			centerText(gc, item.n, dispX/2, dispY/2-gc:getStringHeight(item.n)*(#self.items/2-item.id+1/2)*2/3)
			if item.id==self.x then
				gc:setColorRGB(rectColor)
				gc:drawRect(dispX/2-gc:getStringWidth(item.n)/2, dispY/2-gc:getStringHeight(item.n)*(#self.items/2-item.id+1)*2/3, gc:getStringWidth(item.n), gc:getStringHeight(item.n)*2/3)
			end
		end
		gc:setFont("sansserif", "r", 24)
		if self.title~=nil then
			if self.titleColor~=nil then
				gc:setColorRGB(self.titleColor)
			else
				gc:setColorRGB(textColor)
			end
			centerText(gc, self.title, dispX/2, gc:getStringHeight(self.title)/2, "top")
		end
	end
	
	function menu:setBackSecs(secs)
		self.backSecs=secs
	end
	
	function menu:timer()
		if millis()-self.prevBackTime>self.backSecs*1000 then
			if self.curBack<#self.backs then
				self.curBack=self.curBack+1
			else
				self.curBack=1
			end
			self.prevBackTime=millis()
		end
		disp:invalidate()
	end
	
	function menu:addBackground(img)
		self.backs[#self.backs+1]=img:copy(dispX+1, dispY)
	end
	
	function menu:activate()
		self:setDefaults()
	end
	
	function menu:Open()
		self.name="menu"
		self:setDefaults()
	end
	
	function menu:Close()
		self:deactivate()
	end
	
	function menu:enterKey()
		self:deactivate()
		if self.name==processes[#processes].name then
			PushProcess(self.items[self.x].i)
		end
		disp:invalidate()
	end
	function menu:mouseDown(x, y)
		self:deactivate()
		PushProcess(self.items[self.x].i)
		disp:invalidate()
	end
	
	function menu:setTitle(title, color)
		self.title=title
		self.titleColor=color
	end
end

do readme=cpyTable(process)
	readme.hlpInfo=""
	readme.dispHelp=D2Editor.newRichText()
	function readme:Open()
		--self:deactivate()
		--self.inputEnabled=true
		self.dispHelp:setVisible(false)
		self.dispHelp:setText(self.hlpInfo, 1)
		self.dispHelp:move(0, 0)
		self.dispHelp:setBorder(0)
		self.dispHelp:setReadOnly(true)
		self.dispHelp:resize(dispX, dispY)
		self.dispHelp:setVisible(true)
	end
	function readme:timer()
		self.dispHelp:setFocus(true)
	end
	function readme:Close()
		self.dispHelp:setFocus(false)
		self.dispHelp:setVisible(false)
	end
	function readme:escapeKey()
		PullProcess()
	end
	function readme:backspaceKey()
		PullProcess()
	end
	function readme:setText(text)
		self.hlpInfo=text
	end
end

do settings=cpyTable(process)--first param format: ant(current setting/amount/value/data), name(name of setting, like number mines), typ(type of setting, like "num" or "namelist"), numOn(if needed), data(if needed). second param: id(name of setting group, like game or menu or whatever)
	local list={}
	local index={}
	local x=1
	local curId=""
	
	function getNum(key)
		print(key)
		if key=="left" then
			return -1
		elseif key=="right" then
			return 1
		end
		return 0
	end
	
	function getVals(lis, key)
		local numData={}
		
		for j, i in pairs(lis.data) do
			if type(i)=="function" then
				numData[j]=i(cpyTable(list[curId]), getNum(key))
			else
				numData[j]=cpyTable(i)
			end
		end
		
		return numData
	end
	
	local functions={
		["num"]=function(lis, key)--data: inc(increment), min, max
			local numData=getVals(lis, key)
			local newAnt=lis.ant+numData["inc"]*getNum(key)
			if numData["min"] and numData["min"]>round(newAnt) then
				newAnt=numData["max"]
			end
			if numData["max"] and numData["max"]<round(newAnt) then
				newAnt=numData["min"]
			end
			return newAnt
		end,
		["namelist"]=function(lis, key)--data["names"] is names
			if lis.data["numOn"]==nil or lis.data["numOn"]==#lis.data then
				lis.data["numOn"]=1
			else
				lis.data["numOn"]=lis.data["numOn"]+1
			end
			lis.ant=lis.data["names"][lis.numOn]
			return lis.ant
		end
	}

	function settings:addFunc(f, typ)
		functions[typ]=f
	end
	
	function settings:getSetting(id)
		return cpyTable(list[id])
	end
	
	function settings:addSetting(sett, id)
		if not list[id] then
			list[id]={}
			index[id]={}
		end
		list[id][sett.n]=cpyTable(sett)
		index[id][#index[id]+1]=sett.n
		list[id][sett.n].id=#index[id]
	end
	
	function settings:addSettings(setts, id)
		curId=id
		for _, i in pairs(setts) do
			self:addSetting(i, id)
		end
	end
	
	function settings:setId(id)
		curId=id
	end
	
	function settings:arrowKey(key)
		print(x, #index[curId])
		if key=="down" then
			if x>1 then
				x=x-1
			else
				x=#index[curId]
			end
		elseif key=="up" then
			if x<#index[curId] then
				x=x+1
			else
				x=1
			end
		elseif key=="left" or key=="right" then
			local tmp=index[curId][x]
			if functions[list[curId][tmp].typ] then
				list[curId][tmp].ant=functions[list[curId][tmp].typ](cpyTable(list[curId][tmp]), key)
			end
		end
		disp:invalidate()
		print(x, #index[curId])
	end
	
	function settings:paint(gc)
		for _, item in pairs(list[curId]) do
			gc:setColorRGB(0x000000)
			local j=item.ant
			if type(j)=="number" then
				j=round(j)
			end
			centerText(gc, item.name..": "..j, dispX/2, dispY/2+gc:getStringHeight(item.name..item.ant)*(#index[curId]/2-item.id)*2/3)
			if item.id==x then
				gc:drawRect(dispX/2-gc:getStringWidth(item.name..": "..j)/2, dispY/2+gc:getStringHeight(item.name..": "..j)*(#index[curId]/2-item.id-1/2)*2/3, gc:getStringWidth(item.name..": "..j), gc:getStringHeight(item.name..": "..j)*2/3)
			end
		end
	end
	
	function settings:escapeKey()
		PullProcess()
	end
end

-------------------------

-- End of lib\menu.lua --

-------------------------


authorEmail="andyhsstudent@gmail.com"
errorDetailsEnabled=true

do errorHandler=process()
	local curError=""
	local line=0
	local recovery=nil
	local tmp=false
	
	local dispHelp=D2Editor.newRichText()
	
	function errorHandler:setError(l, e)
		curError=e
		line=l
	end
	
	function errorHandler:Open()
		tmp=lockTopProcess
		lockTopProcess=true
		dispHelp:setVisible(false)
		dispHelp:setText("Here is the technical info:\n"..curError, 1)
		dispHelp:move(0, 60)
		dispHelp:setBorder(5)
		dispHelp:setBorderColor(0xFF0000)
		dispHelp:setReadOnly(true)
		dispHelp:resize(dispX, 85)
		dispHelp:setVisible(true)
		disp:invalidate()
	end
	
	function errorHandler:Close()
		dispHelp:setFocus(false)
		dispHelp:setVisible(false)
		if not tmp then
			unLockProcesses()
		end
		if recovery~=nil then
			recovery()
		end
	end
	
	function errorHandler:paint(gc)
		gc:setColorRGB(0x0000FF)
		gc:fillRect(0,0,dispX,dispY)
		gc:setColorRGB(0x000000)
		gc:setFont("serif", "r", 12)
		gc:drawString("Oops. Something happened :(", 0, 0)
		gc:drawString("Press enter to go back", 0, gc:getStringHeight("Oops. Something happened :("))
		gc:drawString("or escape to go to main menu", 0, 2*gc:getStringHeight("Oops. Something happened :("))
		gc:setFont("serif", "r", 12)
		gc:drawString("Send the error message to:" , 0, 150)
		gc:drawString(authorEmail , 0, 150+gc:getStringHeight("Send the error message to:"))
	end
	
	function errorHandler:enterKey()
		PullProcess()
	end
	
	function errorHandler:escapeKey()
		PullProcess()
		while #processes>1 do
			PullProcess()
		end
		collectgarbage()
	end
	
	function errorHandler:setRecovery(func)
		recovery=func
	end
end

errorHandler:setRecovery(procRecovery)

function handleError(l, e)
	if errorDetailsEnabled then
		errorHandler:setError(l, e)
		PushProcess(errorHandler)
	end
end

platform.registerErrorHandler(function(l,e,stack,locals)
	handleError(l, e)
	return true
end)